
#event_handler("evntChrPerkDelay","procChrPerkDelay");
#include "interface\perks\perks_init.c"; //Added by Levis, There is only 1 perks init file so we can just use include can't we?

object ChrPerksList;

extern void extrnInitPerks();

void InitPerks()
{
	//if( LoadSegment("interface\perks\perks_init.c") )
	//{
		extrnInitPerks();
		//UnloadSegment("interface\perks\perks_init.c");
	//}
}

bool CheckPerkAvailable(string perkName)
{
	//if( CheckCharacterPerk(refUsedCharacter,perkName) ) return false;
	//return true;
	//Levis Disable perks -->
	int i, dn;
	aref arCur, arDis;
	string needName;
	makearef(arDis,ChrPerksList.list.(perkName).disable);
	dn = GetAttributesNum(arDis);
	
	for(i=0; i<dn; i++)
	{
		arCur = GetAttributeN(arDis,i);
		needName = GetAttributeName(arCur);
		switch(needName)
		{
			case "iRealismMode":
				if(REALISTIC_ABILITIES == 1 && iRealismMode>=sti(GetAttributeValue(arCur)))		{ return false; } // PB: To allow REALISTIC_ABILITIES to override the Realism Mode
			break;
			
			case "REALISTIC_ABILITIES":
				if(REALISTIC_ABILITIES == 1 && iRealismMode == 0)								{ return true;  } // PB: To ensure Arcade Game Mode does override the Build Default
				if(REALISTIC_ABILITIES >= sti(GetAttributeValue(arCur)))						{ return false; }
			break;
			
			case "StorylineVar":
				if(sti(GetStorylineVar(FindCurrentStoryline(), GetAttributeValue(arCur))) < 1)	{ return false; }
			break;
		}
	}
	//Levis Disable perks <--
	return true;
}

//Levis Check rank
bool CheckPerkRank(ref character, string perkName)
{
	if( CheckAttribute(ChrPerksList,"list."+perkName + ".rank"))
	{
		if( CheckAttribute(character,"rank"))
		{
			int Playerrank = makeint(character.rank);
			int Perkrank = makeint(ChrPerksList.list.(perkName).rank);
			if(Playerrank >= Perkrank)
			{
				return true;
			}
		}
		return false;
	}
	return true;
}

int GetPerkRank(string perkName)
{
	if( CheckAttribute(ChrPerksList,"list."+perkName + ".rank"))
	{
		int Perkrank = makeint(ChrPerksList.list.(perkName).rank);
		return Perkrank;
	}
	return 0;
}

//Check perk conditions
bool CheckPerkConditions(ref refUsedCharacter, string PerkName)
{
	aref perkARef; 
	makearef(perkARef, ChrPerksList.list.(PerkName).condition);
	string abilName;
	bool canassign = true;
	for(int i = 0; i < GetAttributesNum(perkARef); i++)
	{
		abilName = GetAttributeName(GetAttributeN(perkARef,i));
		if(!CheckCharacterPerk(refUsedCharacter, abilName))
		{
			canassign = false;
		}
	}
	return canassign;
}

//Levis Locked Perks -->
bool CheckCharacterPerkLocked(ref Character, string perkName)
{
	if(ALLOW_LOCKED_PERKS)
	{
		if(PerkHasLock(perkName))
		{
			if( CheckAttribute(Character,"perks.unlocked."+perkName))
			{
				return false;
			}
			if(IsPassenger(character) && !IsMainCharacter(character))
			{
				//If the main character has the perk unlocked then all officers will have it unlocked to. not the other way around tough.
				return CheckCharacterPerkLocked(GetMainCharacter(), perkName);
			}
			return true;
		}
	}
	return false;
}

bool PerkHasLock(string perkName)
{
	//Checks if the perk has a lock
	if( CheckAttribute(ChrPerksList,"list."+perkName + ".locked"))
	{
		return true;
	}
	return false;
}

bool UnlockPerkCharacter(ref Character, string perkName)
{
	if(!CheckAttribute(Character,"perks.unlocked."+perkName))
	{
		//Only show notification if player is main character
		if(IsMainCharacter(Character))
		{
			int lngFileID = LanguageOpenFile("AbilityDescribe.txt");
			string Text = LanguageConvertString(lngFileID,"Unlocked");
			string Name = LanguageConvertString(lngFileID,perkName);
			PlaySound("INTERFACE\notebook.wav");
			Logit(Text + " " + Name);
			LanguageCloseFile(lngFileID);
		}
		Character.perks.unlocked.(perkName) = true;
		return true;
	}
	return false;
}

void LockPerk(string perkName)
{
	ChrPerksList.list.(perkName).locked = true;
}
// <--Levis Locked Perks

bool CheckCharacterPerk(ref chref, string perkName)
{
	/*if(isOfficerPerk(chref, perkName)) //Only when the perk is in the scope of this character
	{
		if (CheckPerkAvailable(perkName)) //Levis disable perks
		{
			if( CheckAttribute(chref,"perks.list."+perkName) ) return true;
		}
	}
	return false;*/
	return CheckPerkForGroup(chref, perkName); //Levis
}

void ActivateCharacterPerk(ref chref, string perkName)
{
	if( !CheckAttribute(&ChrPerksList,"list."+perkName) )
	{
		trace("Invalid perk name - " + perkName);
		return;
	}

	int timeDelay = 0;
	int timeDuration = 0;

	if( CheckAttribute(&ChrPerksList,"list."+perkName+".TimeDuration") )
	{	timeDelay = sti(ChrPerksList.list.(perkName).TimeDuration);
		timeDuration = timeDelay;
	}
	if( CheckAttribute(&ChrPerksList,"list."+perkName+".TimeDelay") )
	{	timeDelay = sti(ChrPerksList.list.(perkName).TimeDelay);
		if(timeDuration<=0)	{timeDuration=timeDelay;}
	}

	chref.perks.list.(perkName).delay = timeDelay;
	chref.perks.list.(perkName).active = timeDuration;

	if(sti(chref.index)==GetMainCharacterIndex())
	{
		AddPerkToActiveList(perkName);
	}

	if(timeDelay>0) PostEvent("evntChrPerkDelay",1000,"sl",perkName,sti(chref.index));
	Event("eSwitchPerks","l",sti(chref.index));
}

bool GetCharacterPerkUsing(ref chref, string perkName)
{
	/*if(!isOfficerPerk(chref, perkName)) return false; //not in the scope of this character -Levis
	if( !CheckAttribute(chref,"perks.list."+perkName) ) return false;
	if( CheckAttribute(chref,"perks.list."+perkName+".delay") ) return false;
	return true;*/
	return CheckPerkForGroup(chref, perkName); //Levis
}

bool GetOfficersPerkUsing(ref chref, string perkName)
{
	/*int i, cn;
	if(IsMainCharacter(chref))
	{
		if(GetCharacterPerkUsing(chref, perkName))
		{
			return true;
		}

		int num = GetPassengersQuantity(chref);
		for(i = 0; i < num; i++)
		{
			cn = GetPassenger(chref, i);
			if(cn < 0)
				continue;

			ref chr = GetCharacter(cn);
			if(CheckAttribute(chr,"prisoned") || IsCompanion(chr) || IsTrader(chr))
				continue;

			if(GetCharacterPerkUsing(GetCharacter(cn), perkName))
			{
				return true;
			}
		}
	}
	else
	{
		// current char is officer 0
		for(i = 0; i < 4; i++)
		{
			cn = GetOfficersIndex(chref , i);
			if(cn<0) {continue;}
			if( GetCharacterPerkUsing(&Characters[cn], perkName) ) {return true;}
		}
	}
	return false;*/
	return CheckPerkForGroup(chref, perkName); //Levis
}

bool IsCharacterPerkOn(ref chref, string perkName)
{
	aref arRoot, arBase;
	makearef(arRoot,chref.perks.list);
	if( !CheckAttribute(arRoot,perkName) ) return false;
	makearef(arBase,ChrPerksList.list.(perkName));
	if( CheckAttribute(arBase,"TimeDuration") || CheckAttribute(arBase,"TimeDelay") ) {
		return CheckAttribute(arRoot,perkName+".active");
	}
	return true;
}

// NK -->
bool GetPerkBool(ref chr, string perk, bool summ) //return char+officers perk check if summ, else return char perk check
{
	if(summ) return GetOfficersPerkUsing(&chr, perk);
	return IsCharacterPerkOn(&chr, perk);
}
// NK <--

void CharacterPerkOff(ref chref, string perkName)
{
	DeleteAttribute(chref,"perks.list."+perkName+".active");
	Event("eSwitchPerks","l",sti(chref.index));
	if(sti(chref.index)==GetMainCharacterIndex())
	{
		DelPerkFromActiveList(perkName);
	}
}

bool CheckOfficersPerk(ref chref, string perkName)
{
	/*int i,cn;
	if(CheckPerkAvailable(perkName)) //Levis disable perks
	{
		for (i = 0; i < 4; i++)
		{
			cn = GetOfficersIndex(chref, "" + i);
			if (cn < 0) continue;
			if (IsCharacterPerkOn(GetCharacter(cn), perkName)) return true;
		}
	}
	return false;*/
	return CheckPerkForGroup(chref, perkName);
}

bool CheckCompanionsPerk(ref chref, string perkName)
{
	int i,cn;
	if(CheckPerkAvailable(perkName)) //Levis disable perks
	{
		for(i=0; i<4; i++)
		{
			cn = GetCompanionIndex(chref,i);
			if(cn>=0)
			{	if( IsCharacterPerkOn(GetCharacter(cn),perkName) )	{return true;}
			}
		}
	}
	return false;
}

void procChrPerkDelay()
{
	string perkName = GetEventData();
	int chrIdx = GetEventData();

	aref arPerk;
	makearef(arPerk,Characters[chrIdx].perks.list.(perkName));
	if( !CheckAttribute(arPerk,"delay") ) return;
	int delay = sti(arPerk.delay);
	delay--;

	if( CheckAttribute(arPerk,"active") )
	{
		int iActive = sti(arPerk.active)-1;
		if( iActive>0 )	{arPerk.active = iActive;}
		else
		{
			CharacterPerkOff(GetCharacter(chrIdx),perkName);
		}
	}

	if( delay<=0 )
	{	DeleteAttribute(&Characters[chrIdx],"perks.list."+perkName+".delay");
		DeleteAttribute(&Characters[chrIdx],"perks.list."+perkName+".active");
		PostEvent("evntPerkAgainUsable",1);
	}
	else
	{
		Characters[chrIdx].perks.list.(perkName).delay = delay;
		PostEvent("evntChrPerkDelay",1000,"sl",perkName,chrIdx);
	}
}

void EnableUsingAbility(ref chref,string perkName)
{
	Event("evntChrPerkDelay","sl",perkName,sti(chref.index));
}

void PerkLoad()
{
//	int iRDTSC = RDTSC_B();

	ref mainCh = GetMainCharacter();
	string locName = mainCh.location;
	aref arPerksRoot,arPerk;
	int i,j,n,tmpi;

	for(i=0; i<CHARACTERS_QUANTITY; i++) // NK 05-04-05 use CHARACTERS_QUANTITY. This is weird, though, it doesn't count fantoms.
	{
		if(Characters[i].location == locName)
		{
			makearef(arPerksRoot,Characters[i].perks.list);
			n = GetAttributesNum(arPerksRoot);
			for(j=0; j<n; j++)
			{
				arPerk = GetAttributeN(arPerksRoot,j);
				if( CheckAttribute(arPerk,"delay") )
				{
					tmpi = sti(arPerk.delay);
					if( tmpi>0 )
					{
						PostEvent("evntChrPerkDelay",1000,"sl",GetAttributeName(arPerk),i);
					}
				}
			}
		}
	}

//	trace("TIME!!! PerkLoad() = " + RDTSC_E(iRDTSC));
}

void ClearActiveChrPerks(ref chref)
{
	aref arPerksRoot, arPerk;
	int i,n,j,cn;

	for (j = 0; j < 4; j++)
	{
		cn = GetOfficersIndex(chref,j);
		if( cn<0 ) {continue;}
		makearef( arPerksRoot, Characters[cn].perks.list );
		n = GetAttributesNum(arPerksRoot);
		for (i = 0; i < n; i++)
		{
			arPerk = GetAttributeN(arPerksRoot,i);
			if (CheckAttribute(arPerk,"delay"))		DeleteAttribute(arPerk,"delay");
			if (CheckAttribute(arPerk,"active"))	DeleteAttribute(arPerk,"active");
		}
	}
}

void adjustFreePerks(ref character)
{
	aref allPerks, chrPerks;
	makearef(allPerks, ChrPerksList.list);
	makearef(chrPerks, character.perks.list);
	int availablePerks = GetAttributesNum(allPerks) - GetAttributesNum(chrPerks);
	if(sti(character.perks.freepoints) > availablePerks)
		character.perks.freepoints = availablePerks;
}

bool isPerkAssignable(ref character, string perkName, int freePoints)
{
	//Check if already assigned
	if(CheckPerkForSingleCharacter(character, perkName)) return false;
	//Check free points
	if(freePoints < GetPerkCost(perkName)) return false;
	//Locked Perks
	if(CheckCharacterPerkLocked(character, perkName)) return false;
	//Added by Levis, Just to be sure
	if(!CheckPerkAvailable(perkName)) return false;
	//Check Rank
	if(!CheckPerkRank(character, perkName)) return false;
	//Check Conditions
	if(!CheckPerkConditions(character, PerkName)) return false;
	//Removed by Levis, should already be done in Perklist and else in CheckPerkAvaible.
	/*aref disable;
	makearef(disable, ChrPerksList.list.(perkName).disable);
	if(CheckAttribute(disable, "iRealismMode") && sti(disable.iRealismMode) <= iRealismMode)
		return false;
	if(CheckAttribute(disable, "REALISTIC_ABILITIES") && disable.REALISTIC_ABILITIES <= REALISTIC_ABILITIES)
		return false;

	aref conditions;
	makearef(conditions, ChrPerksList.list.(perkName).condition);
	int num = GetAttributesNum(conditions);
	int n;
	for(n = 0; n < num; n++)
	{
		string perk = GetAttributeName(GetAttributeN(conditions, n));
		makearef(disable, ChrPerksList.list.(perkName).disable);
		if(!CheckAttribute(disable, "iRealismMode") || sti(disable.iRealismMode) > iRealismMode)
		{
			if(!CheckAttribute(disable, "REALISTIC_ABILITIES") || disable.REALISTIC_ABILITIES > REALISTIC_ABILITIES)
			{
				if(!CheckCharacterPerk(character, perk))
					return false;
			}
		}
	}*/
	return true;
}

bool isPerkAssignableNoLock(ref character, string perkName, int freePoints)
{
	//Check if already assigned
	if(CheckPerkForSingleCharacter(character, perkName)) return false;
	//Check free points
	if(freePoints < GetPerkCost(perkName)) return false;
	//Added by Levis, Just to be sure
	if(!CheckPerkAvailable(perkName)) return false;
	//Check Rank
	if(!CheckPerkRank(character, perkName)) return false;
	//Check Conditions
	if(!CheckPerkConditions(character, PerkName)) return false;
	return true;
}

bool isPerkExisting(string perkName)
{
	return CheckAttribute(&ChrPerksList, "list." + perkName);
}

// Aconcagua: moved to here
//Levis show only officer perks
bool isOfficerPerk(ref character, string perkName)
{
	if(IsMainCharacter(character)) return true; //Main Character has all perks
	//Check if perk is a combat perk, if so return true
	aref allPerks;
	makearef(allPerks, OfficerTypes.Combat.perks);
	int num = GetAttributesNum(allPerks);
	int n;
	string perk;
	for(n = 0; n < num; n++)
	{
		perk = GetAttributeName(GetAttributeN(allPerks, n));
		if(perk == perkName)
		{
			return true;
		}
	}
	//Else check if the perk is for this specific officer
	string officerType = OFFIC_TYPE_RANDCHAR;
	if(CheckAttribute(character,"quest.officertype")) officerType = character.quest.officertype;
	makearef(allPerks, OfficerTypes.(officerType).perks);
	num = GetAttributesNum(allPerks);
	for(n = 0; n < num; n++)
	{
		perk = GetAttributeName(GetAttributeN(allPerks, n));
		if(perk == perkName)
		{
			return true;
		}
	}
	return false;
}

//Levis definitive function to check if the perk should contribute or not
bool CheckPerkForSingleCharacter(ref character, string perkName)
{
	if(isOfficerPerk(character, perkName)) //Only when the perk is in the scope of this character
	{
		if (CheckPerkAvailable(perkName)) //Levis disable perks
		{
			if( CheckAttribute(character,"perks.list."+perkName) ) return true;
		}
	}
	return false;
}

bool CheckPerkForGroup(ref character, string perkName)
{
	int i,cn;
	aref allPerks;
	ref chr;
	//If we are checking for another character
	if(!IsOfficer(character))
	{
		//Check the character
		if(!isOfficerPerk(character, perkName)) return false;
		if(CheckPerkinList(character, perkName)) return true;
		//Check the compagnions of the character
		num = GetPassengersQuantity(character);
		for(i = 0; i < num; i++)
		{
			cn = GetPassenger(character, i);
			if(cn < 0) continue;
			chr = GetCharacter(cn);
			if(CheckAttribute(chr,"prisoned") || IsCompanion(chr) || IsTrader(chr)) continue;
			if(!isOfficerPerk(chr, perkName)) continue;
			if(CheckPerkinList(chr, perkName)) return true;
		}
	}
	//First check if the perk is a combat perk or special perk
	makearef(allPerks, OfficerTypes.Combat.perks);
	int num = GetAttributesNum(allPerks);
	string perk;
	for(i = 0; i < num; i++)
	{
		perk = GetAttributeName(GetAttributeN(allPerks, i));
		if(perk == perkName)
		{
			//It's one of the combat perks so check if its selected yet
			return CheckPerkinList(character, perkName);
		}
	}
	//Now check for the special perks
	//First check the maincharacter
	if(CheckPerkinList(GetMainCharacter(), perkName)) return true;
	//Else look trough the officers
	num = GetPassengersQuantity(GetMainCharacter());
	for(i = 0; i < num; i++)
	{
		cn = GetPassenger(GetMainCharacter(), i);
		if(cn < 0) continue;
		chr = GetCharacter(cn);
		if(CheckAttribute(chr,"prisoned") || IsCompanion(chr) || IsTrader(chr)) continue;
		if(!isOfficerPerk(chr, perkName)) continue;
		if(CheckPerkinList(chr, perkName)) return true;
	}
	return false;
}

bool CheckPerkinList(ref Character, string perkName)
{
	if( !CheckAttribute(character,"perks.list."+perkName) ) return false;
	if( CheckAttribute(character,"perks.list."+perkName+".delay") ) return false;
	return true;
}

//Levis Add perkcost-->
int GetPerkCost(string perkName)
{
	aref Perk;
	makearef(Perk,ChrPerksList.list.(perkName));
	if (CheckAttribute(Perk,"cost") && PERK_MULTIPLIER>0)
	{
		int cost = makeint(sti(Perk.cost)*PERK_MULTIPLIER);
		if(cost>0)
		{
			return cost;
		}
		else
		{
			return 1;
		}
	}
	return 1;
}
//<-- Levis Add perkcost
