// NK added 05-07-03 as centralized HP setting thing.
// PB: Simplified and uniformized for all characters
float ResetHP(ref chr)
{
	float HP = CHAR_START_HITPOINTS;
	float level = makefloat(GetLevel(&chr));
	if (level == 0) level = 20;	// LDH 08Feb09
	if(CheckAttribute(chr, "HPBonus")) HP += stf(chr.HPBonus);
	HP += (level - 1) * CHAR_HITPOINTS_PER_LEVEL;
// LDH --> Added toughness perk from elrapido verson of ResetMaxHP
	if(IsCharacterPerkOn(chr, "Toughness"))
	{
		HP = HP * 1.1;			// 10% health bonus for the tough guys
		chr.chr_ai.hp_dlt = LAI_DEFAULT_DLTHP * TOUGHNESS_REGEN_MULT; // higher regeneration rate, default is 0.1 - LDH 14Apr09
	}
// LDH <--
	chr.chr_ai.hp = HP;
	chr.chr_ai.hp_max = HP;
	chr.old.chr_ai.hp = HP;
	chr.old.chr_ai.hp_max = HP;
	return HP;
}

int ChangeHPBonus(ref chr, int offset)
{
	if(CheckAttribute(chr, "HPBonus")) offset += sti(chr.HPBonus);
	chr.HPBonus = offset;
	return sti(offset);
}

//----------------------------------------------------------------------------------------------------------------
//--------------------Create Officer---------------------------------------------------------------------------------

// with additions by NK to use this for all char creation, and to differentiate between friends and enemies, and for generating captains
// and to include difficulty level.
void LAi_Create_Officer(int rankch, ref Npchar)
{
	ref PChar = GetMainCharacter();
	//check to see if enemy or friend.
	int pLuck = GetSummonSkillFromName(PChar,SKILL_SNEAK);
	int pLead = GetSummonSkillFromName(PChar,SKILL_LEADERSHIP);
	int pRank = sti(PChar.rank) + rankch;
	if(pRank < 1) pRank = 1;
	int nRank = 1;
	float caprankmult = 1.0; //for use if captain, and based on shipclass
	//two new attributes for NPCs, friend and officer (bool); captain type uses officertype.
	bool isfriend = CheckAttribute(Npchar, "friend") && sti(Npchar.friend); // NK finally implement this 05-05-10
	bool officer = CheckAttribute(Npchar, "officer"); // && isfriend; //implement friend later;
	if(officer) isfriend = true; //tempfix until I implement friendchecks.
	bool captain = false;
	int cShipClass = 0;
	//Log_SetStringToLog(Npchar.quest.officertype + ", officer " + officer);

	if(!CheckAttribute(Npchar,"quest.officertype")) Npchar.quest.officertype = OFFIC_TYPE_RANDCHAR;
	
	switch(Npchar.quest.officertype)
	{
		case OFFIC_TYPE_CAPMERCHANT:
			caprankmult = 0.5 * (2.0/3.0 + (makefloat(GetDifficulty())-1.0) / 1.5);
			captain = true;
			break;

		case OFFIC_TYPE_CAPNAVY:
			caprankmult = 0.8 * (2.0/3.0 + (makefloat(GetDifficulty())-1.0) / 1.5);
			captain = true;
			break;

		case OFFIC_TYPE_CAPPIRATE:
			caprankmult = 1.0 * (2.0/3.0 + (makefloat(GetDifficulty())-1.0) / 1.5);
			captain = true;
			break;
	}

	// JRMM: Lower Officer Levels -->
	if(isfriend)
	{
		nRank = makeint((pRank/1.5) + (pLead / 5.0) + (pLuck / 5.0));
	}
	else
	{
		nRank = makeint((pRank/1.5) + (pLead / 5.0) + (pLuck / 5.0));
	}
	// JRMM: Lower Officer Levels <--
	nRank = makeint(makefloat(nRank) * caprankmult);
	//Log_SetStringToLog("Preclamp, " + /*Npchar.id + " (" + Npchar.name + " " + Npchar.lastname + "), " + Npchar.quest.officertype + ", has rank " + */nRank + "; mult " + caprankmult);
	
	if(captain)
	{
		//Log_SetStringToLog("Cap");
		//note: here caprankmult is re-assigned, to account for pchar's officers; this has been disabled, as it's now done in AI.
		//caprankmult = 1 + makefloat(GetOfficersQuantity(PChar)*5 + rand(GetOfficersQuantity(PChar)*5))/10.0;
		cShipClass = 8 - GetCharacterShipClass(Npchar);
		if(cShipClass > 8) cShipClass = 1;
		if(GetCharacterShipType(Npchar) == SHIP_FORT) cShipClass = 8;
		if(nRank < makeint(pow((cShipClass),1.25))) nRank = makeint(pow((cShipClass),1.25));
		if(GetDifficulty() < 4 && Npchar.quest.officertype != OFFIC_TYPE_CAPPIRATE && nRank > makeint(pow((cShipClass),1.5)*2.5)) nRank = makeint(pow((cShipClass),1.5)*2.5);
		//Npchar.oldrank = makeint(nRank);
		//nRank = makeint(nRank * caprankmult);
	}
	//Log_SetStringToLog("Clamped, " + /*Npchar.id + " (" + Npchar.name + " " + Npchar.lastname + "), " + Npchar.quest.officertype + ", has rank " + */nRank + "; mult " + caprankmult);
	if (isfriend && pLead == 10) nRank++;
	if (nRank < 1) nRank = 1;
	Npchar.rank = makeint(nRank);

	Npchar.perks.FreePoints = nRank;
	Npchar.skill.Freeskill = nRank * ADD_SKILLPOINTS_PERLEVEL; // TIH changed to user configurable setting Nov14'06
	//Log_SetStringToLog(" " + Npchar.perks.FreePoints + " " + Npchar.skill.Freeskill);

	if(officer) Npchar.quest.OfficerPrice = makeint((nRank * 2 + 10)*100);

	int Skillvariation;
	Skillvariation = intRet(isfriend, nRank - makeint(pLead / 2), nRank + makeint(pLuck/3));
	LAi_Officer_SetSkillmodifiers_and_Perks(Npchar,Skillvariation);
	LAi_SetSkill_on_Modifier(Npchar);

	//Npchar.Experience = 1000;

//---------------------------------Set Officer Variation based on MainChar Luck-------------------------------------------------------------------------------------------------
	if (rand(9) < pLuck) {Npchar.perks.FreePoints = makeint(Npchar.perks.Freepoints) +1;}
	Npchar.skill.Freeskill = makeint(Npchar.skill.Freeskill) + rand(makeint(pLuck / 3));

/* Aconcagua: did not work - there were never free perks...
//MAXIMUS 20.09.2006 [so, freeskill and freepoints will not exceed maximal possible amount] -->	
	aref arPerksRoot;
	int n,j;
	makearef(arPerksRoot,Npchar.perks.list);
	n = GetAttributesNum(arPerksRoot);
	int freePerks = 0;
	int usedPerks = 0;
	for(j=0; j<n; j++)
	{
		string perkName = GetAttributeName(GetAttributeN(arPerksRoot,j));//MAXIMUS: correcting free perks -[17.02.2007]->
		if(!CheckCharacterPerk(Npchar,perkName)) { freePerks = freePerks + 1; }
		else { usedPerks = usedPerks + 1; }
//		arPerk = GetAttributeN(arPerksRoot,j);
//		if(IsCharacterPerkOn(PChar,GetAttributeName(arPerk))) numActivePerks = numActivePerks+1;
//		if(Npchar.perks.FreePoints > makeint(n-numActivePerks)) Npchar.perks.FreePoints = makeint(n-numActivePerks);
	}
	if(freePerks==0) { Npchar.perks.FreePoints = 0; }
	else
	{
		if(CheckAttribute(Npchar,"perks.FreePoints") && sti(Npchar.perks.FreePoints)>freePerks) { Npchar.perks.FreePoints = freePerks; }
	}//MAXIMUS: correcting free perks <-[17.02.2007]-
//MAXIMUS 20.09.2006 [so, freeskill and freepoints will not exceed maximal possible amount] <--
*/
	adjustFreePerks(Npchar); // Aconcagua: using new function instead

	/*if(captain) // for use with above officerqty scale
	{
		nRank = makeint(Npchar.oldrank);
		DeleteAttribute(Npchar, "oldrank");
		Npchar.rank = makeint(nRank);
	}*/
	float mhp = LAI_DEFAULT_HP;
	//mhp += intRet(isfriend, intRet(officer, nRank * (14 - GetDifficulty()*2), nRank * (8-GetDifficulty())), nRank * (3+GetDifficulty()));
	mhp += intRet(officer, nRank * makeint(11-GetDifficulty()), (nRank - 1) * CHAR_HITPOINTS_PER_LEVEL);    // LDH 05Dec06
	//Log_SetStringToLog(mhp + ", mult " + (GetDifficulty()*3))
	LAi_SetHP(Npchar,mhp,mhp);
	Npchar.experience = CalculateExperienceFromRank(nRank);
}

//--------------------------------------------------------------------------------
//----------SelectPerksForOfficers------------------------------------------------
//--------------------------------------------------------------------------------

void SelectPerksForOfficers(ref Npchar, int LeadershipValue, int CombatValue, int CannonValue, int NavigatorValue, int GrapplingValue, int DefenceValue, int QMasterValue, int RepairValue)
{
	int FreePerks = makeint(Npchar.Perks.Freepoints);
	int perkCost;
	int PerksSelect = (LeadershipValue + CannonValue + NavigatorValue + GrapplingValue + DefenceValue + QMasterValue + RepairValue)*2;
	int minloops = 10;
	while (FreePerks > 0)
	{
		if(rand(PerksSelect) > CombatValue)
		{
			string officerType = OFFIC_TYPE_RANDCHAR;
			if(CheckAttribute(Npchar,"quest.officertype")) officerType = Npchar.quest.officertype;
			perkCost = selectPerkForOfficerType(Npchar, officerType , FreePerks);
			PerksSelect -= perkCost;
		}
		else
		{
			perkCost = selectPerkForOfficerType(Npchar, "Combat", FreePerks);
			CombatValue -= perkCost;
		}
		FreePerks -= perkCost;
		minloops --;
		//Add a little escape function so we could also leave with some points still assignable
		if(minloops < 0 && rand(FreePerks)<1)
		{
			break;
		}
		//Let's just use the officer type shall we -Levis
		/*int PerksSelect = LeadershipValue + CombatValue + CannonValue + NavigatorValue + GrapplingValue + DefenceValue + QMasterValue + RepairValue;
		if (PerksSelect == 0)
		{
			Npchar.Perks.FreePoints = Makeint(Npchar.Perks.Freepoints) + FreePerks;
                        return;
		}
		PerksSelect = Rand(PerksSelect - 1) + 1;

		if (PerksSelect <= CombatValue)
		{
			// there is no officer type for combat value! ('abordage' does not work)
			//perkCost = SelectPerks_Combat(Npchar, FreePerks);
			perkCost = selectPerkForOfficerType(Npchar, "Combat", FreePerks); //Changed by Levis to make things easier
			if(perkCost > 0) {FreePerks = FreePerks - perkCost;} else {CombatValue = 0;}
			continue;
		}
		PerksSelect = PerksSelect - CombatValue;

		if (PerksSelect <= LeadershipValue)
		{
			perkCost = selectPerkForOfficerType(Npchar, OFFIC_TYPE_FIRSTMATE, FreePerks);
			if(perkCost > 0) {FreePerks = FreePerks - perkCost;} else {LeadershipValue = 0;}
			continue;
		}
		PerksSelect = PerksSelect - LeadershipValue;

		if (PerksSelect <= CannonValue)
		{
			perkCost = selectPerkForOfficerType(Npchar, OFFIC_TYPE_CANNONEER, FreePerks);
			if(perkCost > 0) {FreePerks = FreePerks - perkCost;} else {CannonValue = 0;}
			continue;
		}
		PerksSelect = PerksSelect - CannonValue;

		if (PerksSelect <= NavigatorValue)
		{
			perkCost = selectPerkForOfficerType(Npchar, OFFIC_TYPE_NAVIGATOR, FreePerks);
			if(perkCost > 0) {FreePerks = FreePerks - perkCost;} else {NavigatorValue = 0;}
			continue;
		}
		PerksSelect = PerksSelect - NavigatorValue;

		if (PerksSelect <= GrapplingValue)
		{
			perkCost = selectPerkForOfficerType(Npchar, OFFIC_TYPE_BOATSWAIN, FreePerks);
			if(perkCost > 0) {FreePerks = FreePerks - perkCost;} else {GrapplingValue = 0;}
			continue;
		}
		PerksSelect = PerksSelect - GrapplingValue;

		if (PerksSelect <= DefenceValue)
		{
			perkCost = selectPerkForOfficerType(Npchar, OFFIC_TYPE_DOCTOR, FreePerks);
			if(perkCost > 0) {FreePerks = FreePerks - perkCost;} else {DefenceValue = 0;}
			continue;
		}
		PerksSelect = PerksSelect - DefenceValue;

		if (PerksSelect <= QMasterValue)
		{
			perkCost = selectPerkForOfficerType(Npchar, OFFIC_TYPE_QMASTER, FreePerks);
			if(perkCost > 0) {FreePerks = FreePerks - perkCost;} else {QMasterValue = 0;}
			continue;
		}
		PerksSelect = PerksSelect - QMasterValue;

		if (PerksSelect <= RepairValue)
		{
			perkCost = selectPerkForOfficerType(Npchar, OFFIC_TYPE_CARPENTER, FreePerks);
			if(perkCost > 0) {FreePerks = FreePerks - perkCost;} else {RepairValue = 0;}
			continue;
		}

		// Aconcagua: none could be selected - simply abort loop now
		// (actually, we should never get here...)
                break;
		*/
	}
	Npchar.Perks.FreePoints = FreePerks;
}

// Aconcagua: return int:
// > 0: cost of selected perk
// < 0: could not assign perk
//Moved to other function by Levis
/*int SelectPerks_Combat(ref Npchar, int freePoints)
{
	int P_BasicDefence = 0;
	if(isPerkAssignable(Npchar, "BasicDefence", freePoints)) {P_BasicDefence = 15;}
	int P_AdvancedDefence = 0;
	if(isPerkAssignable(Npchar, "AdvancedDefence", freePoints)) {P_AdvancedDefence = 10;}
	int P_Toughness = 0;
	if(isPerkAssignable(Npchar, "Toughness", freePoints)) {P_Toughness = 10;}
	int P_Critical = 0;
	if(isPerkAssignable(Npchar, "CriticalHit", freePoints)) {P_Critical = 8;}
	int P_Swordplay = 0;
	if(isPerkAssignable(Npchar, "SwordplayProfessional", freePoints)) {P_Swordplay = 10;}
	int P_Gunman = 0;
	if(isPerkAssignable(Npchar, "Gunman", freePoints)) {P_Gunman = 5;}
	int P_Professional = 0;
	if(isPerkAssignable(Npchar, "GunProfessional", freePoints)) {P_Professional = 5;}
        int P_GunFighter = 0;
        if(isPerkAssignable(Npchar, "GunFighter", freePoints)) {P_GunFighter = 5;}
	int P_Rush = 0;
        if(isPerkAssignable(Npchar, "Rush", freePoints)) {P_Rush = 1;}

	int Perkselect = P_BasicDefence + P_AdvancedDefence + P_Toughness + P_Swordplay + P_Critical + P_Gunman + P_Professional + P_GunFighter + P_Rush;
	//MAXIMUS 20.09.2006 -->
	if (Perkselect == 0)
		return -1;

	if (Perkselect <= P_BasicDefence) {Npchar.Perks.List.BasicDefence = "1"; return GetPerkCost("BasicDefence");}
	Perkselect = Perkselect - P_BasicDefence; 
	if (Perkselect <= P_AdvancedDefence) {Npchar.Perks.List.AdvancedDefence = "1"; return GetPerkCost("AdvancedDefence");}
	Perkselect = Perkselect - P_AdvancedDefence;
	//MAXIMUS 20.09.2006 -->
	if(Perkselect <= P_Toughness) {Npchar.Perks.List.Toughness = "1"; return GetPerkCost("Toughness");}
	Perkselect = Perkselect - P_Toughness;
	//MAXIMUS 20.09.2006 <--
	if (Perkselect <= P_Swordplay) {Npchar.Perks.List.SwordplayProfessional = "1"; return GetPerkCost("SwordplayProfessional");}
	Perkselect = Perkselect - P_Swordplay;
	if (Perkselect <= P_Critical) {Npchar.Perks.List.CriticalHit = "1"; return GetPerkCost("CriticalHit");}
	Perkselect = Perkselect - P_Critical;
	if (Perkselect <= P_Gunman) {Npchar.Perks.List.Gunman = "1"; return GetPerkCost("Gunman");}
	Perkselect = Perkselect - P_Gunman;
	if (Perkselect <= P_Professional) {Npchar.Perks.List.GunProfessional = "1"; return GetPerkCost("GunProfessional");}
	Perkselect = Perkselect - P_Professional;
	if (Perkselect <= P_GunFighter) {Npchar.Perks.List.GunFighter = "1"; return GetPerkCost("GunFighter");}
	Perkselect = Perkselect - P_GunFighter;
	if (Perkselect <= P_Rush) {Npchar.Perks.List.Rush = "1"; return GetPerkCost("Rush");}
	
	return -1;
}*/

//---------------------------------SetSkillmodifiers------------------------------------------------------------------------------------------- 
void LAi_Officer_SetSkillmodifiers_and_Perks(ref Npchar, int Skillvariation)
{
	int LeadershipValue = 0;
	int CombatValue = 0;
	int CannonValue = 0;
	int NavigatorValue = 0;
	int GrapplingValue = 0;
	int DefenceValue = 0;
	int QMasterValue = 0;
	int RepairValue = 0;
	int nRank = sti(Npchar.rank);
// added by MAXIMUS [new skill-change] -->
	if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
	{
		for(int c = 0; c < 10; c++)
		{
			string curSkill = GetSkillName(c);
			if(CheckAttribute(Npchar,"skill."+curSkill))
			{
				if(CheckAttribute(Npchar,"skill."+curSkill+".bonus")) { DeleteAttribute(Npchar,"skill."+curSkill+".bonus"); }
			}
		}
		float curSpeed = makefloat(stf(SKILLS_UP_BONUS+100)/100);
		string bonusSkillName = GetRandSkillName(Npchar);
	}
// added by MAXIMUS [new skill-change] <--
	
	switch(Npchar.quest.officertype)
	{
		case OFFIC_TYPE_RANDCHAR:

			Npchar.quest.LeadershipModify = Skillvariation;
			Npchar.quest.FencingModify = Skillvariation*8;
			Npchar.quest.SailingModify = Skillvariation;
			Npchar.quest.AccuracyModify = Skillvariation;
			Npchar.quest.CannonsModify = Skillvariation;
			Npchar.quest.GrapplingModify = Skillvariation;
			Npchar.quest.RepairModify = Skillvariation;
			Npchar.quest.DefenceModify = Skillvariation;
			Npchar.quest.CommerceModify = Skillvariation;
			Npchar.quest.SneakModify = Skillvariation;

			LeadershipValue = Skillvariation;
			CombatValue = Skillvariation*6;
			CannonValue = Skillvariation;
			NavigatorValue = Skillvariation;
			GrapplingValue = Skillvariation;
			DefenceValue = Skillvariation;
			QMasterValue = Skillvariation;
			RepairValue = Skillvariation / 2;
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, 5); // Sulan: reduce crew money
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.(bonusSkillName).bonus = curSpeed;
				bonusSkillName = GetRandSkillName(Npchar);
				Npchar.skill.(bonusSkillName).bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_CIVILIAN:

			Npchar.quest.LeadershipModify = rand(makeint(Skillvariation*1.0));
			Npchar.quest.FencingModify = rand(makeint(Skillvariation*1.25));
			Npchar.quest.SailingModify = rand(makeint(Skillvariation*1.33));
			Npchar.quest.AccuracyModify = rand(makeint(Skillvariation*0.5));
			Npchar.quest.CannonsModify = rand(makeint(Skillvariation*0.5));
			Npchar.quest.GrapplingModify = rand(makeint(Skillvariation*0.75));
			Npchar.quest.RepairModify = rand(makeint(Skillvariation*2.0));
			Npchar.quest.DefenceModify = rand(makeint(Skillvariation*0.75));
			Npchar.quest.CommerceModify = rand(makeint(Skillvariation*2.0));
			Npchar.quest.SneakModify = rand(makeint(Skillvariation*2.0));

			LeadershipValue = rand(makeint(Skillvariation*1.0));
			CombatValue = rand(makeint(Skillvariation*1.25));
			CannonValue = rand(makeint(Skillvariation*0.5));
			NavigatorValue = rand(makeint(Skillvariation*1.33));
			GrapplingValue = rand(makeint(Skillvariation*0.75));
			DefenceValue = rand(makeint(Skillvariation*0.75));
			QMasterValue = rand(makeint(Skillvariation*2.0));
			RepairValue = rand(makeint(Skillvariation));
//			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, rand(25)*2 + 25);
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, rand(5)*2 + 2);   // Sulan: reduce crew money
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.(bonusSkillName).bonus = curSpeed;
				bonusSkillName = GetRandSkillName(Npchar);
				Npchar.skill.(bonusSkillName).bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_CAPMERCHANT:

			Npchar.quest.LeadershipModify = 75;
			Npchar.quest.FencingModify = 50;
			Npchar.quest.SailingModify = 120;
			Npchar.quest.AccuracyModify = 50;
			Npchar.quest.CannonsModify = 40;
			Npchar.quest.GrapplingModify = 67;
			Npchar.quest.RepairModify = 120;
			Npchar.quest.DefenceModify = 67;
			Npchar.quest.CommerceModify = 150;
			Npchar.quest.SneakModify = 100;

			LeadershipValue = 150;
			CombatValue = 50;
			CannonValue = 50;
			NavigatorValue = 100;
			GrapplingValue = 67;
			DefenceValue = 67;
			QMasterValue = 200;
			RepairValue = 100;
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, 5);      // Sulan: reduce crew money: 500
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Sailing.bonus = curSpeed;
				Npchar.skill.Commerce.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_CAPNAVY:

			Npchar.quest.LeadershipModify = 100;
			Npchar.quest.FencingModify = 70;
			Npchar.quest.SailingModify = 80;
			Npchar.quest.AccuracyModify = 100;
			Npchar.quest.CannonsModify = 100;
			Npchar.quest.GrapplingModify = 67;
			Npchar.quest.RepairModify = 50;
			Npchar.quest.DefenceModify = 80;
			Npchar.quest.CommerceModify = 25;
			Npchar.quest.SneakModify = 25;

			LeadershipValue = 100;
			CombatValue = 70;
			CannonValue = 150;
			NavigatorValue = 85;
			GrapplingValue = 67;
			DefenceValue = 100;
			QMasterValue = 30;
			RepairValue = 20;
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, 12);  //Sulan: reduce crew money 120
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Accuracy.bonus = curSpeed;
				Npchar.skill.Defence.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_CAPPIRATE:

			Npchar.quest.LeadershipModify = 100;
			Npchar.quest.FencingModify = 90;
			Npchar.quest.SailingModify = 110;
			Npchar.quest.AccuracyModify = 80;
			Npchar.quest.CannonsModify = 80;
			Npchar.quest.GrapplingModify = 100;
			Npchar.quest.RepairModify = 50;
			Npchar.quest.DefenceModify = 75;
			Npchar.quest.CommerceModify = 50;
			Npchar.quest.SneakModify = 75;

			LeadershipValue = 100;
			CombatValue = 90;
			CannonValue = 80;
			NavigatorValue = 110;
			GrapplingValue = 100;
			DefenceValue = 75;
			QMasterValue = 50;
			RepairValue = 30;
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = makeint(pow((Rand(3) + 1),2) * GetRandCharMoney(Npchar, 5));   // Sulan: reduce crew money 50
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Cannons.bonus = curSpeed;
				Npchar.skill.Grappling.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_BOATSWAIN:
			SetModifyValuesForRole(Npchar, 150, 100, Skillvariation, 120, Skillvariation);
			Npchar.quest.GrapplingModify = 100;
			Npchar.quest.RepairModify = 30;
			if (nRank >= 10) {Npchar.quest.RepairModify = 70;}

			CombatValue = 60;
			GrapplingValue = 60;
			DefenceValue = 25;
			if (nRank >= 10) 
			{
				LeadershipValue = 25;
				QMasterValue = 25;
				CannonValue = 0;
				NavigatorValue = 0;
			}
			if (nRank >=15) {NavigatorValue = 10;}
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, 5);      // Sulan: reduce crew money 50
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Leadership.bonus = curSpeed;
				Npchar.skill.Fencing.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_CANNONEER:
			SetModifyValuesForRole(Npchar, 150, 100, Skillvariation, 50, Skillvariation);
			if(nRank >= 10) {Npchar.quest.GrapplingModify = 40;}

			CombatValue = 40;
			CannonValue = 70;
			if(nRank >=12)
			{
				GrapplingValue = 15;
				DefenceValue = 15;
				QMasterValue = 0;
				NavigatorValue = 0;
			}
			if (nRank >= 18) {NavigatorValue = 10;}
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, 5);    // Sulan: reduce crew money 50
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Cannons.bonus = curSpeed;
				Npchar.skill.Accuracy.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_QMASTER:
			SetModifyValuesForRole(Npchar, 150, 100, Skillvariation, 50, Skillvariation);
			if(nRank >= 10) {Npchar.quest.DefenceModify = 40;}

			CombatValue = 20;
			QMasterValue = 70;
			RepairValue = 30;
			if(nRank >= 10)
			{
				CannonValue = 0;
				GrapplingValue = 15;
				NavigatorValue = 0;
				DefenceValue = 15;
			}
			if (nRank >=14) {NavigatorValue = 10;}
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, 8);     // Sulan: reduce crew money 75
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Commerce.bonus = curSpeed;
				Npchar.skill.Sneak.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_NAVIGATOR:
			SetModifyValuesForRole(Npchar, 150, 100, Skillvariation, 50, Skillvariation);
			Npchar.quest.DefenceModify = 80;
			if(nRank >= 10) {Npchar.quest.SneakModify = 40;}

			CombatValue = 30;
			NavigatorValue = 70;
			if(nRank >= 11){DefenceValue = 25; LeadershipValue = 20;}
			if (nRank >= 15) {QMasterValue = 10;}
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, 7);      // Sulan: reduce crew money 67
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Sailing.bonus = curSpeed;
				Npchar.skill.Grappling.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_FIRSTMATE:
			SetModifyValuesForRole(Npchar, 150, 100, Skillvariation, 70, 60);
			if(nRank >= 10) {Npchar.quest.CommerceModify = 40;}

			LeadershipValue = 60;
			CombatValue = 50;
			DefenceValue = 50;
			if (nRank >= 9) {QMasterValue = 30;}
			if (nRank >= 14) {NavigatorValue = 15;}
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, 9);    // Sulan: reduce crew money 90
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Leadership.bonus = curSpeed;
				Npchar.skill.Defence.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;
// MAXIMUS officers -->

		case OFFIC_TYPE_CARPENTER:
			SetModifyValuesForRole(Npchar, 150, 100, Skillvariation, 50, 50);
			if(nRank >= 10) {Npchar.quest.CommerceModify = 40;}

			CombatValue = 50;
			RepairValue = 50;
			if (nRank >= 10) 
			{
				LeadershipValue = 25;
			}
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, 8);   // Sulan: reduce crew money 75
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Defence.bonus = curSpeed;
				Npchar.skill.Repair.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_DOCTOR:
			SetModifyValuesForRole(Npchar, 150, 100, Skillvariation, Skillvariation, 40);
			Npchar.quest.LeadershipModify = 80;
			if(nRank >= 10) {Npchar.quest.CommerceModify = 40;}

			CombatValue = 50;
			DefenceValue = 50;
			if (nRank >= 10) 
			{
				LeadershipValue = 25;
			}
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = GetRandCharMoney(Npchar, 7);   // Sulan: reduce crew money 67
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Defence.bonus = curSpeed;
				Npchar.skill.Sneak.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;

		case OFFIC_TYPE_ABORDAGE:
			// SetModifyValuesForRole(Npchar, ...) // abordage has not defined officer type!
			Npchar.quest.LeadershipModify = 100;
			Npchar.quest.FencingModify = 150;
			Npchar.quest.SailingModify = Skillvariation;
			Npchar.quest.AccuracyModify = Skillvariation;
			Npchar.quest.CannonsModify = Skillvariation;
			Npchar.quest.GrapplingModify = 100;
			Npchar.quest.RepairModify = Skillvariation;
			Npchar.quest.DefenceModify = 75;
			Npchar.quest.CommerceModify = Skillvariation;
			Npchar.quest.SneakModify = 75;

			if (nRank >= 10) 
			{
				LeadershipValue = 25;
			}
			CombatValue = 100;
			if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar)) Npchar.money = pow((Rand(3) + 1),2) * GetRandCharMoney(Npchar, 5);  // Sulan: reduce crew money 50
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.Grappling.bonus = curSpeed;
				Npchar.skill.Fencing.bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		break;
// MAXIMUS officers <--

		//default: // scheffnow - bfs
			Npchar.quest.LeadershipModify = Skillvariation;
			Npchar.quest.FencingModify = 45; 
			Npchar.quest.SailingModify = Skillvariation;
			Npchar.quest.AccuracyModify = Skillvariation;
			Npchar.quest.CannonsModify = Skillvariation;
			Npchar.quest.GrapplingModify = Skillvariation;
			Npchar.quest.RepairModify = Skillvariation;
			Npchar.quest.DefenceModify = Skillvariation;
			Npchar.quest.CommerceModify = Skillvariation;
			Npchar.quest.SneakModify = Skillvariation;
			//if(nRank >= 10) {Npchar.quest.CommerceModify = 40;}

			LeadershipValue = 15;
			CombatValue = 20;
			CannonValue = 10;
			NavigatorValue = 10;
			GrapplingValue = 10;
			DefenceValue = 10;
			QMasterValue = 20;
			Npchar.money = GetRandCharMoney(Npchar, 5);          // Sulan: reduce crew money 50
// added by MAXIMUS [new skill-change] -->
			if(AUTO_SKILL_SYSTEM && !IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
			{
				Npchar.skill.(bonusSkillName).bonus = curSpeed;
				bonusSkillName = GetRandSkillName(Npchar);
				Npchar.skill.(bonusSkillName).bonus = curSpeed;
			}
// added by MAXIMUS [new skill-change] <--
		
			//if (nRank >= 9) {QMasterValue = 30;}
			//if (nRank >= 14) {NavigatorValue = 15;}
	}
//----------------------------------Set Perks for Officers--------------------------------------------------------------------------------------------------------------------------------

	if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
	{
		// compared to previous version: always deletes all perks
		// even if new ones are created... (few had been forgotten before)
		aref list;
		makearef(list, Npchar.perks.List);
		DeleteAttribute(list, "");
		SelectPerksForOfficers(Npchar, LeadershipValue, CombatValue, CannonValue, NavigatorValue, GrapplingValue, DefenceValue, QMasterValue, RepairValue);
	}
}


//----------------------------------Set Skills for Officers----------------------------------------------------------------------------------			

void LAi_SetSkill_on_Modifier(ref Npchar)
{
	if(!IsMainCharacter(Npchar) && !IsPlayerParty(Npchar))
	{
		Npchar.skill.Leadership = 1; DeleteAttribute(&Npchar,"skill.Leadership.mod"); // NK/GZ items mod
		Npchar.skill.Fencing = 1; DeleteAttribute(&Npchar,"skill.Fencing.mod"); // NK/GZ items mod
		Npchar.skill.Sailing = 1; DeleteAttribute(&Npchar,"skill.Sailing.mod"); // NK/GZ items mod
		Npchar.skill.Accuracy = 1; DeleteAttribute(&Npchar,"skill.Accuracy.mod"); // NK/GZ items mod
		Npchar.skill.Cannons = 1; DeleteAttribute(&Npchar,"skill.Cannons.mod"); // NK/GZ items mod
		Npchar.skill.Grappling = 1; DeleteAttribute(&Npchar,"skill.Grappling.mod"); // NK/GZ items mod
		Npchar.skill.Repair = 1; DeleteAttribute(&Npchar,"skill.Repair.mod"); // NK/GZ items mod
		Npchar.skill.Defence = 1; DeleteAttribute(&Npchar,"skill.Defence.mod"); // NK/GZ items mod
		Npchar.skill.Commerce = 1; DeleteAttribute(&Npchar,"skill.Commerce.mod"); // NK/GZ items mod
		Npchar.skill.Sneak = 1; DeleteAttribute(&Npchar,"skill.Sneak.mod"); // NK/GZ items mod
	}

	int Skillpoints = makeint(Npchar.skill.freeskill);
	int PerkRest = 0;
	int SumValue,Placeskill;
	SumValue = makeint(Npchar.quest.LeadershipModify) + makeint(Npchar.quest.FencingModify) + makeint(Npchar.quest.SailingModify) + makeint(Npchar.quest.AccuracyModify) + makeint(Npchar.quest.CannonsModify) + makeint(Npchar.quest.GrapplingModify) + makeint(Npchar.quest.RepairModify) + makeint(Npchar.quest.DefenceModify) + makeint(Npchar.quest.CommerceModify) + makeint(Npchar.quest.SneakModify);

	for (int i = 0; i < Skillpoints; i++)
	{
		Placeskill = Rand(SumValue - 1) + 1;

		if (Placeskill <= makeint(Npchar.quest.LeadershipModify)) {Npchar.skill.Leadership = makeint(Npchar.skill.Leadership) + 1; continue;}
		Placeskill = Placeskill - makeint(Npchar.quest.LeadershipModify);
		if (Placeskill <= makeint(Npchar.quest.FencingModify))	  {Npchar.skill.Fencing = makeint(Npchar.skill.Fencing) + 1; continue;}
		Placeskill = Placeskill - makeint(Npchar.quest.FencingModify);
		if (Placeskill <= makeint(Npchar.quest.SailingModify))	  {Npchar.skill.Sailing = makeint(Npchar.skill.Sailing) + 1; continue;}
		Placeskill = Placeskill - makeint(Npchar.quest.SailingModify);
		if (Placeskill <= makeint(Npchar.quest.AccuracyModify))	  {Npchar.skill.Accuracy = makeint(Npchar.skill.Accuracy) + 1; continue;}
		Placeskill = Placeskill - makeint(Npchar.quest.AccuracyModify);
		if (Placeskill <= makeint(Npchar.quest.CannonsModify))	  {Npchar.skill.Cannons = makeint(Npchar.skill.Cannons) + 1; continue;}
		Placeskill = Placeskill - makeint(Npchar.quest.CannonsModify);
		if (Placeskill <= makeint(Npchar.quest.GrapplingModify))  {Npchar.skill.Grappling = makeint(Npchar.skill.Grappling) + 1; continue;}
		Placeskill = Placeskill - makeint(Npchar.quest.GrapplingModify);
		if (Placeskill <= makeint(Npchar.quest.RepairModify))	  {Npchar.skill.Repair = makeint(Npchar.skill.Repair) + 1; continue;}
		Placeskill = Placeskill - makeint(Npchar.quest.RepairModify);
		if (Placeskill <= makeint(Npchar.quest.DefenceModify))	  {Npchar.skill.Defence = makeint(Npchar.skill.Defence) + 1; continue;}
		Placeskill = Placeskill - makeint(Npchar.quest.DefenceModify);
		if (Placeskill <= makeint(Npchar.quest.CommerceModify))	  {Npchar.skill.Commerce = makeint(Npchar.skill.Commerce) + 1; continue;}
		Placeskill = Placeskill - makeint(Npchar.quest.CommerceModify);
		if (Placeskill <= makeint(Npchar.quest.SneakModify))	  {Npchar.skill.Sneak = makeint(Npchar.skill.Sneak) + 1; continue;}
		PerkRest = PerkRest + 1;
	}  

	if(makeint(Npchar.skill.Leadership) >= 10) {PerkRest = PerkRest + makeint(Npchar.skill.Leadership) - 10; Npchar.skill.Leadership = 10;} 
	if(makeint(Npchar.skill.Fencing)	>= 10) {PerkRest = PerkRest + makeint(Npchar.skill.Fencing) - 10; Npchar.skill.Fencing = 10;}
	if(makeint(Npchar.skill.Sailing)	>= 10) {PerkRest = PerkRest + makeint(Npchar.skill.Sailing) - 10; Npchar.skill.Sailing = 10;}
	if(makeint(Npchar.skill.Accuracy)	>= 10) {PerkRest = PerkRest + makeint(Npchar.skill.Accuracy) - 10; Npchar.skill.Accuracy = 10;}
	if(makeint(Npchar.skill.Cannons)	>= 10) {PerkRest = PerkRest + makeint(Npchar.skill.Cannons) - 10; Npchar.skill.Cannons = 10;}
	if(makeint(Npchar.skill.Grappling)	>= 10) {PerkRest = PerkRest + makeint(Npchar.skill.Grappling) - 10; Npchar.skill.Grappling = 10;}
	if(makeint(Npchar.skill.Repair) >= 10) {PerkRest = PerkRest + makeint(Npchar.skill.Repair) - 10; Npchar.skill.Repair = 10;}
	if(makeint(Npchar.skill.Defence)	>= 10) {PerkRest = PerkRest + makeint(Npchar.skill.Defence) - 10; Npchar.skill.Defence = 10;}
	if(makeint(Npchar.skill.Commerce)	>= 10) {PerkRest = PerkRest + makeint(Npchar.skill.Commerce) - 10; Npchar.skill.Commerce = 10;}
	if(makeint(Npchar.skill.Sneak)	>= 10) {PerkRest = PerkRest + makeint(Npchar.skill.Sneak) - 10; Npchar.skill.Sneak = 10;}

	Npchar.skill.Freeskill = PerkRest;

// KK -->
	if (!CharacterHasShip(Npchar)) return;
	bool bskip = false;
	if (sti(NPchar.nation) != PIRATE)
		bskip = rand(100) > 98;
	else
		bskip = rand(100) < 50;
	if (EnableLimitedShipClass() && !bskip) {
		int minshipclass = GetShipMinClassForSkills(sti(Npchar.skill.Leadership), sti(Npchar.skill.Sailing));
		int NPClass = GetCharacterShipClass(Npchar);
		while (NPClass < minshipclass) {
			Npchar.skill.Leadership = sti(Npchar.skill.Leadership) + 1;
			Npchar.skill.Sailing = sti(Npchar.skill.Sailing) + 1;
			minshipclass = GetShipMinClassForSkills(sti(Npchar.skill.Leadership), sti(Npchar.skill.Sailing));
		}
		Npchar.skill.Leadership = sti(Npchar.skill.Leadership) + rand(10 - sti(Npchar.skill.Leadership));
		Npchar.skill.Sailing = sti(Npchar.skill.Sailing) + rand(10 - sti(Npchar.skill.Sailing));
	}
// <-- KK
}
